package com.police.ejb;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;

import javax.ejb.Stateless;

@Stateless

	

public class PoliceBean implements PoliceRemote{
	Connection conn;
	PreparedStatement stmt;
	boolean failure=false;
	
	
	public PoliceBean() {
		
	
	}
	public String viewCrime(String id) {
		String temp;
		id=queryValidate(id);	
		try{
					Class.forName("com.ibm.db2.jcc.DB2Driver");
					conn = DriverManager.getConnection("jdbc:db2://localhost:50000/PRISIONM:retrieveMessagesFromServerOnGetMessage=true;","inst","sister");
					
					String query="select * from sch1.prisoner_bio where pid=?"; 
					PreparedStatement p=conn.prepareStatement(query);
					p.setString(1,id);
					ResultSet rs=p.executeQuery();
					if(!rs.next())
					{
						return "<b><font color='black'>ERROR:Causes May Be,</font></b><br/><span style='font-weight:none;color:red;'>Prisoner With Specified Prisoner Id Doesn't Exist.</span>";
					}
					String result = "<form name='entry1_form' id='entry1_form' ><b><h4>Prisoner Photos</h4><br/><table class='resulter_div' border='1' style='border-collapse:collapse;'>" +
							"<tr><th><b>Left</b></th><th><b>Front</b></th><th><b>Right</b></th><th><b>Finger Print</b></th></tr>" +
							"<tr>" +
							"<td><img src='https://localhost:9445/ManageWEB/ImageViewer?no=3&pid="+id+"' height='100' width='90' border='1' /></td><td><img src='https://localhost:9445/ManageWEB/ImageViewer?no=4&pid="+id+"' height='100' width='90' border='1'/></td><td><img src='https://localhost:9445/ManageWEB/ImageViewer?no=1&pid="+id+"' height='100' width='90' border='1'/></td><td><img src='https://localhost:9445/ManageWEB/ImageViewer?no=2&pid="+id+"' height='100' width='90' border='1'/></td></tr></table><hr/><br/><h4>Prisoner Details<br/>" +
									"<table class='resulter_div' border='1' style='border-collapse:collapse;'><tr><th>Name</th><th>Fathers Name</th><th>Nationality</th><th>Gender</th></tr>";
					query="select pname,fname,nationality,gender from sch1.prisoner_bio where pid=?"; 
					p=conn.prepareStatement(query);
					p.setString(1,id);
					rs=p.executeQuery();
					while(rs.next())
					{
					result+="<tr><td>"+rs.getString(1)+"</td><td>"+rs.getString(2)+"</td><td>"+rs.getString(3)+"</td><td>"+rs.getString(4)+"</td></tr>";
					}
					result+="</table><br/><h4>Crime Report</h4><br/>";
					result+="<table class='resulter_div' border='1' style='border-collapse:collapse;'><tr><th>Jail NO</th><th>FIR Number</th><th>Case Number</th><th>In-Date</th><th>Release-Date</th><th>Crime</th><th>Sentence</th></tr>";
					query="select jno,firno,caseno,indate,reldate,crime,sentence from sch1.prisioner where pid=? order by indate"; 
					p=conn.prepareStatement(query);
					p.setString(1,id);
					rs=p.executeQuery();
					while(rs.next())
					{
					result+="<tr><td>"+rs.getString(1)+"</td><td>"+rs.getString(2)+"</td><td>"+rs.getString(3)+"</td><td>"+rs.getString(4)+"</td><td>"+rs.getString(5)+"</td><td>"+rs.getString(6)+"</td><td>"+rs.getString(7)+"</td></tr>";
					}
					
					result+="</table></b></form>";
					
					//result.replaceAll("<tr>", "<tr onclick='entry_fun_result()'>");
					
					
					return result;
		}
				catch(Exception e){
				failure = true;	 
				return "<b><font color='black'>ERROR:Causes May Be,</font></b><br/><span style='font-weight:none;'>1.&nbsp;Details Entered May Be Incorrect <br/> 2.&nbsp;There May Be Error With Our DataBase<br/> Server</span>";
				}
				finally{try{
					conn.close();
				} catch (SQLException e) {
					// TODO Auto-generated catch block
					
				}
				}
			}
	public String queryValidate(String check_string)
	{
		check_string= check_string.replaceAll("<", " ");
	 	return check_string.replaceAll(">", " ");
	}
	public String searchPrisoner(String name, String nationality, String crime,String gender, String age1, String age2) {
		name=queryValidate(name);
		nationality=queryValidate(nationality);
		crime=queryValidate(crime);
		gender=queryValidate(gender);
		age1=queryValidate(age1);
		age2=queryValidate(age2);
		try{
    	  PreparedStatement p=null;
			String result = "<form name='entry1_form' ><b><table class='resulter_div' border='1' style='border-collapse:collapse;'>";
			Class.forName("com.ibm.db2.jcc.DB2Driver");
			conn = DriverManager.getConnection("jdbc:db2://localhost:50000/PRISIONM:retrieveMessagesFromServerOnGetMessage=true;","inst","sister");
			String query1="select xmlserialize(content xmlelement(name \"tr\",xmlelement(name \"td\",xmlelement(name \"img\",xmlattributes('https://localhost:9445/ManageWEB/ImageViewer?no=1&pid=' || d.pid as \"src\"))),xmlelement(name \"td\", xmlelement(name \"ul\",xmlelement(name \"li\",'Id: ' || d.pid),xmlelement(name \"li\",'Name: ' || d.pname),xmlelement(name \"li\",'Is In Jail: ' || d.isinjail),xmlelement(name \"li\",'Is Alive: ' ||  d.isalive),xmlelement(name \"li\", d.pdob),xmlelement(name \"resilience\",xmlattributes(d.pid as \"name\"))    )))as clob(12000)) as \"result\" from sch1.prisoner_bio d,sch1.prisioner e where e.pid=d.pid and d.pname like ?  and d.gender like ? and ( year(Current date-d.pdob)<=? and year(Current date-d.pdob)>= ?) and (e.crime like ? or d.nationality like ?)";
			String query2="select xmlserialize(content xmlelement(name \"tr\",xmlelement(name \"td\",xmlelement(name \"img\",xmlattributes('https://localhost:9445/ManageWEB/ImageViewer?no=1&pid=' || d.pid as \"src\"))),xmlelement(name \"td\", xmlelement(name \"ul\",xmlelement(name \"li\",'Id: ' || d.pid),xmlelement(name \"li\",'Name: ' || d.pname),xmlelement(name \"li\",'Is In Jail: ' || d.isinjail),xmlelement(name \"li\",'Is Alive: ' ||  d.isalive),xmlelement(name \"li\", d.pdob),xmlelement(name \"resilience\",xmlattributes(d.pid as \"name\"))    )))as clob(12000)) as \"result\" from sch1.prisoner_bio d,sch1.prisioner e where e.pid=d.pid and d.pname like ?  and d.gender like ? and ( year(Current date-d.pdob)<=? and year(Current date-d.pdob)>= ?) and e.crime like ? ";
			String query3="select xmlserialize(content xmlelement(name \"tr\",xmlelement(name \"td\",xmlelement(name \"img\",xmlattributes('https://localhost:9445/ManageWEB/ImageViewer?no=1&pid=' || d.pid as \"src\"))),xmlelement(name \"td\", xmlelement(name \"ul\",xmlelement(name \"li\",'Id: ' || d.pid),xmlelement(name \"li\",'Name: ' || d.pname),xmlelement(name \"li\",'Is In Jail: ' || d.isinjail),xmlelement(name \"li\",'Is Alive: ' ||  d.isalive),xmlelement(name \"li\", d.pdob),xmlelement(name \"resilience\",xmlattributes(d.pid as \"name\"))    )))as clob(12000)) as \"result\" from sch1.prisoner_bio d,sch1.prisioner e where e.pid=d.pid and d.pname like ?  and d.gender like ? and ( year(Current date-d.pdob)<=? and year(Current date-d.pdob)>= ?) and d.nationality like ?";
			
			if(gender==null)gender="";
			
			if(crime.equals("") && nationality.equals("")){
				nationality="";
				crime="";
				p=conn.prepareStatement(query1);
				p.setString(5,"%"+crime+"%");
				p.setString(6,"%"+nationality+"%");
							}
			else if (nationality.equals("")){
				p=conn.prepareStatement(query2);
				p.setString(5,"%"+crime+"%");
								
			}
			else if(crime.equals("")){
				p=conn.prepareStatement(query3);
				p.setString(5,"%"+nationality+"%");
				
			}
			else{
				p=conn.prepareStatement(query1);
				p.setString(5,"%"+crime+"%");
				p.setString(6,"%"+nationality+"%");
				
			}
			
			p.setString(1,"%"+name+"%");
			p.setString(2,"%"+gender+"%");
			p.setInt(3,Integer.parseInt(age1));
			p.setInt(4,Integer.parseInt(age2));
			ResultSet rs=p.executeQuery();
			while(rs.next())
			{
			result+=rs.getString(1);
			}
			result+="</table></b></form>";
			
			//result.replaceAll("<tr>", "<tr onclick='entry_fun_result()'>");
			
			
			return result;
}
		catch(Exception e){
		failure = true;	 
		return "<b><font color='black'>ERROR:Causes May Be,</font></b><br/><span style='font-weight:none;'>1.&nbsp;Details Entered May Be Incorrect <br/> 2.&nbsp;There May Be Error With Our DataBase<br/> Server</span>"+e.toString();
		}
		finally{try{
			conn.close();
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			
		}
		}
	}

}
