package com.datam.ejb;
import java.sql.Connection;
import java.sql.Date;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.Calendar;

import javax.ejb.Stateless;

@Stateless
public class DatamBean implements DatamRemote {
	Connection conn;
	
	PreparedStatement stmt;
	boolean failure=false;
	
	public DatamBean() {
		try{
			
			Class.forName("com.ibm.db2.jcc.DB2Driver");
			
					
		}
		catch(Exception e){
		failure = true;	
		}
 
	}

	

	public String addParole(String jno, String id, String date, String reason,String police) {
		jno=queryValidate(jno);
		id=queryValidate(id);
		date=queryValidate(date);
		reason=queryValidate(reason);
		police=queryValidate(police);
		
		
		boolean in_or_not=false;
		try{
			conn = DriverManager.getConnection("jdbc:db2://localhost:50000/PRISIONM:retrieveMessagesFromServerOnGetMessage=true;","inst","sister");
			
			if(failure==false)
			{
				stmt=conn.prepareStatement("select pid from sch1.prisioner where  jno=? ");
				stmt.setString(1, jno);
				ResultSet rs=stmt.executeQuery();
			while(rs.next())
			{
					if(id.equals(rs.getString(1)))
					{
					in_or_not=true;	
					break;
							}
			}	
				
				if(in_or_not)
				{
										
			    stmt=conn.prepareStatement("insert into sch1.parole_reg(id,jno,outdate,expindate,polaccom,reason) values(?,?,Current date,?,?,?)");
				stmt.setString(1,id);
				stmt.setString(2,jno);
				stmt.setString(3,date);
				stmt.setString(4,police);
				stmt.setString(5,reason);
				int no=stmt.executeUpdate();
					if(no>=1)
						return "true";
					else
						return "Details May Be Wrongly Entered";
				}
				else
				{
					return "not present already";
				}
			}
			else
			{
				return "false";
			}
			
			}
		catch(Exception e){
			if((e.toString()).indexOf("datetime")!=-1)
				return "<b><font color='black'>ERROR:Causes May Be,</font></b><br/><span style='font-weight:none;'>1.&nbsp;There May Be Error With Our DataBase<br/> Server</span><br/>2.&nbsp;Check Your Date Format ";
			else
				return "<b><font color='black'>ERROR:Causes May Be,</font></b><br/><span style='font-weight:none;'>1.&nbsp;There May Be Error With Our DataBase<br/> Server</span>";
			}
		finally{
			try {
				conn.close();
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		//return "false";

		// TODO Auto-generated method stub
		//return null;	}
	}
	

	public String addStaff(String jno, String name, String id, String category,String area) {
		boolean in_or_not=false;
		jno=queryValidate(jno);
		name=queryValidate(name);
		id=queryValidate(id);
		category=queryValidate(category);
		area=queryValidate(area);
		try{
			conn = DriverManager.getConnection("jdbc:db2://localhost:50000/PRISIONM:retrieveMessagesFromServerOnGetMessage=true;","inst","sister");
			
			if(failure==false)
			{
				stmt=conn.prepareStatement("select id from sch1.staff1 where jno=?");
				stmt.setString(1,jno);
				
				
				
				
				ResultSet rs=stmt.executeQuery();
				while(rs.next())
				{
					if(id.equals(rs.getString(1)))
					{
					in_or_not=true;	
					break; 
					}
				}
				
				if(!in_or_not)
				{
				stmt=conn.prepareStatement("insert into sch1.staff1 values(?,?,?,?,?)");
				stmt.setString(2,id);
				stmt.setString(1,jno);
				stmt.setString(3,name);
				stmt.setString(4,category);
				stmt.setString(5,area);
				int no=stmt.executeUpdate();
					if(no>=1)
						return "true";
					else
						return "Staff Id May Be Wrongly Entered";
				}
				else
				{
					return "already Present";
				}
			}
			else
			{
				return "false";
			}
			
			}catch(Exception e){return "<b><font color='black'>ERROR:Causes May Be,</font></b><br/><span style='font-weight:none;'>1.&nbsp;Staff Id Entered May Be Incorrect <br/> 2.&nbsp;There May Be Error With Our DataBase<br/> Server</span>";}
			finally{
				try {
					conn.close();
				} catch (SQLException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		//return "false";

		// TODO Auto-generated method stub
		//return null;
	}

	public String dairyGen(String jno) {
		int i=0;
		jno=queryValidate(jno);
		// TODO Auto-generated method stub
		String ret="<div id='info_abt_reg' style='z-index:10;height:40px;width:40px;background-color:black;display:none;'></div><center>" +
				"" +
				"<center><b>Prisoners Released Today&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</b><img onclick='if(this.getAttribute(src1)==loc1)this.setAttribute(src1,loc);else{this.setAttribute(src1,loc1);}hider(rep_tab11)' src='images/arrow-right1.gif' style='height:15;width:15;margin-left:28px;cursor:pointer;' /></center>" +
				"<center><div class='rep_tab11'><table border='2' id='rep_tab11' bit='0' style='width:85%;border-collapse:collapse;color:#a00000;margin-top:10px;'><tbody>" +
				"" +
				" <tr><th style='background-image:url(images/header_bg2.png);'>Prisoner Id</th><th style='background-image:url(images/header_bg2.png);'>Crime</th><th style='background-image:url(images/header_bg2.png);'>Imprisoned Date</th><th style='background-image:url(images/header_bg2.png);'>Release Date</th><th style='background-image:url(images/header_bg2.png);'>Reason</th></tr>";
		//int i=0;
		try{
			conn = DriverManager.getConnection("jdbc:db2://localhost:50000/PRISIONM:retrieveMessagesFromServerOnGetMessage=true;","inst","sister");
			
			if(failure==false)
			{
				stmt=conn.prepareStatement("select pid,crime,indate,reldate,reason from sch1.prisioner where jno=? and reldate=Current date");
				stmt.setString(1,jno);
				
								
				ResultSet rs=stmt.executeQuery();
				while(rs.next())
				{	
					i++;
					if(i%2==1)
						ret+="<tr class='rep_tab1' style='background-color:#f0f7f9'><td>"+rs.getString(1)+"</td><td>"+rs.getString(2)+"</td><td>"+rs.getString(3)+"</td><td>"+rs.getString(4)+"</td><td>"+rs.getString(5)+"</td></tr>";
					else
						ret+="<tr class='rep_tab1' style='background-color:#f0f7a6'><td>"+rs.getString(1)+"</td><td>"+rs.getString(2)+"</td><td>"+rs.getString(3)+"</td><td>"+rs.getString(4)+"</td><td>"+rs.getString(5)+"</td></tr>";
				}
				i=0;
				ret+="</tbody></table><br/><br/></div></center><hr style='color:black;width:80%;' />" +
				"<center><b>Prisoners Released Within A Week From Today&nbsp;</b><img onclick='if(this.getAttribute(src1)==loc1)this.setAttribute(src1,loc);else{this.setAttribute(src1,loc1);}hider(rep_tab12)' src='images/arrow-right1.gif' style='height:15;width:15;margin-left:20px;cursor:pointer;' /></center>" +
				"<center><div class='rep_tab12'><table bit='0' id='rep_tab12' border='2' style='margin-top:10px;width:85%;margin-left:10px;margin-right:10px;border-collapse:collapse;color:#a00000;'><tbody>" +
				"<tr><th style='background-image:url(images/header_bg2.png);'>Prisoner Id</th><th style='background-image:url(images/header_bg2.png);'>Crime</th><th style='background-image:url(images/header_bg2.png);'>Imprisoned Date</th><th style='background-image:url(images/header_bg2.png);'>Release Date</th><th style='background-image:url(images/header_bg2.png);'>Reason</th></tr>";
				
				stmt=conn.prepareStatement("select pid,crime,indate,reldate,reason from sch1.prisioner where jno=? and reldate>=Current date and reldate<=Current date + 6 days ");
				stmt.setString(1,jno);
				
								
				 rs=stmt.executeQuery();
				while(rs.next())
				{
					i++;
					if(i%2==1)
						ret+="<tr class='rep_tab2' style='background-color:#F0F7a6'><td>"+rs.getString(1)+"</td><td>"+rs.getString(2)+"</td><td>"+rs.getString(3)+"</td><td>"+rs.getString(4)+"</td><td>"+rs.getString(5)+"</td></tr>";
					else
						ret+="<tr class='rep_tab2' style='background-color:#F0F7f9'><td>"+rs.getString(1)+"</td><td>"+rs.getString(2)+"</td><td>"+rs.getString(3)+"</td><td>"+rs.getString(4)+"</td><td>"+rs.getString(5)+"</td></tr>";
			
					
				}
				ret+="</tbody></table><br/><br/></div></center><hr style='color:black;width:80%;' />" +
						"<center><b>Prisoners Released Within A Month From Today</b><img onclick='if(this.getAttribute(src1)==loc1){this.setAttribute(src1,loc);}else{this.setAttribute(src1,loc1);}hider(rep_tab13)' src='images/arrow-right1.gif' style='height:15;width:15;margin-left:20px;cursor:pointer;' /></center>" +
				"<center><div class='rep_tab13'><table border='2' bit='0' id='rep_tab13' style='margin-top:10px;width:85%;border-collapse:collapse;color:#a00000;'><tbody>" +
				"<tr><th style='background-image:url(images/header_bg2.png);'>Prisoner Id</th><th style='background-image:url(images/header_bg2.png);'>Crime</th><th style='background-image:url(images/header_bg2.png);'>Imprisoned Date</th><th style='background-image:url(images/header_bg2.png);'>Release Date</th><th style='background-image:url(images/header_bg2.png);'>Reason</th></tr>";
				i=0;
				stmt=conn.prepareStatement("select pid,crime,indate,reldate,reason from sch1.prisioner where jno=? and reldate>=Current date and reldate<=Current date + 1 Month - 1 Day ");
				stmt.setString(1,jno);
				
								
				rs=stmt.executeQuery();
				while(rs.next())
				{
					i++;
					if(i%2==1)
						ret+="<tr class='rep_tab3' style='background-color:#f0f7f9'><td>"+rs.getString(1)+"</td><td>"+rs.getString(2)+"</td><td>"+rs.getString(3)+"</td><td>"+rs.getString(4)+"</td><td>"+rs.getString(5)+"</td></tr>";
					else
						ret+="<tr class='rep_tab3' style='background-color:#f0f7a6'><td>"+rs.getString(1)+"</td><td>"+rs.getString(2)+"</td><td>"+rs.getString(3)+"</td><td>"+rs.getString(4)+"</td><td>"+rs.getString(5)+"</td></tr>";
			
					
				}
				
				ret+="</tbody></table><br/><br/></div></center>";
				
				ret=ret.replaceAll("null","");
				
				if(ret!=null)
					return ret;
				//else
					//return "No Staff is Inside";
				
			}
			else
			{
				return "false";
			}
			
			}catch(Exception e){return "We Are Facing Error With Our Database Server.<br/>Sorry For The Convineance.";}
			finally{
				try {
					conn.close();
				} catch (SQLException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}

		return null;
	}


	
	
	
	public String returnRecordByMonth(String jno,int month,int year1) {
		int i=0;
		jno=queryValidate(jno);
		// TODO Auto-generated method stub
		String ret="<div id='info_abt_reg' style='z-index:10;height:40px;width:40px;background-color:black;display:none;'></div><center>" +
				"" +
				"<center><b>Interview Register&nbsp;&nbsp;&nbsp;</b><img onclick='if(this.getAttribute(src1)==loc1)this.setAttribute(src1,loc);else{this.setAttribute(src1,loc1);}hider(rep_tab11)' src='images/arrow-right1.gif' style='height:15;width:15;margin-left:-1px;cursor:pointer;' /></center>" +
				"<center><div class='rep_tab11'><table border='2' id='rep_tab11' bit='0' style='width:85%;border-collapse:collapse;color:#a00000;margin-top:10px;'><tbody>" +
				"" +
				" <tr><th style='background-image:url(images/header_bg2.png);'>Name</th><th style='background-image:url(images/header_bg2.png);'>Address</th><th style='background-image:url(images/header_bg2.png);'>Interview Date</th><th style='background-image:url(images/header_bg2.png);'>Prisoner</th><th style='background-image:url(images/header_bg2.png);'>Relation</th><th style='background-image:url(images/header_bg2.png);'>Accept Status</th></tr>";
		//int i=0;
		try{
			conn = DriverManager.getConnection("jdbc:db2://localhost:50000/PRISIONM:retrieveMessagesFromServerOnGetMessage=true;","inst","sister");
			
			if(failure==false)
			{
				stmt=conn.prepareStatement("select name,address,idate,pid,relation,allowed from sch1.interview_register where jno=? and year(idate)="+year1+" and month(idate)="+month);
				stmt.setString(1,jno);
				
								
				ResultSet rs=stmt.executeQuery();
				while(rs.next())
				{	
					i++;
					if(i%2==1)
						ret+="<tr class='rep_tab1' style='background-color:#f0f7f9'><td>"+rs.getString(1)+"</td><td>"+rs.getString(2)+"</td><td>"+rs.getString(3)+"</td><td>"+rs.getString(4)+"</td><td>"+rs.getString(5)+"</td><td>"+rs.getString(6)+"</td></tr>";
					else
						ret+="<tr class='rep_tab1' style='background-color:#f0f7a6'><td>"+rs.getString(1)+"</td><td>"+rs.getString(2)+"</td><td>"+rs.getString(3)+"</td><td>"+rs.getString(4)+"</td><td>"+rs.getString(5)+"</td><td>"+rs.getString(6)+"</td></tr>";
				}
				i=0;
				ret+="</tbody></table></div></center><br/><hr style='color:black;width:80%;' /><br/>" +
				"<center><b>Duty Register&nbsp;</b><img onclick='if(this.getAttribute(src1)==loc1)this.setAttribute(src1,loc);else{this.setAttribute(src1,loc1);}hider(rep_tab12)' src='images/arrow-right1.gif' style='height:15;width:15;margin-left:20px;cursor:pointer;' /></center>" +
				"<center><div class='rep_tab12'><table bit='0' id='rep_tab12' border='2' style='margin-top:10px;width:85%;margin-left:10px;margin-right:10px;border-collapse:collapse;color:#a00000;'><tbody>" +
				"<tr><th style='background-image:url(images/header_bg2.png);'>Staff Id</th><th style='background-image:url(images/header_bg2.png);'>Date</th><th style='background-image:url(images/header_bg2.png);'>Shift</th><th style='background-image:url(images/header_bg2.png);'>Block</th><th style='background-image:url(images/header_bg2.png);'>Reason</th></tr>";
				
				stmt=conn.prepareStatement("select staffid,date,shift,block,reason from sch1.duty_register where jno=? and year(date)="+year1+" and month(date)="+month);
				stmt.setString(1,jno);
				
								
				 rs=stmt.executeQuery();
				while(rs.next())
				{
					i++;
					if(i%2==1)
						ret+="<tr class='rep_tab2' style='background-color:#F0F7a6'><td>"+rs.getString(1)+"</td><td>"+rs.getString(2)+"</td><td>"+rs.getString(3)+"</td><td>"+rs.getString(4)+"</td><td>"+rs.getString(5)+"</td></tr>";
					else
						ret+="<tr class='rep_tab2' style='background-color:#F0F7f9'><td>"+rs.getString(1)+"</td><td>"+rs.getString(2)+"</td><td>"+rs.getString(3)+"</td><td>"+rs.getString(4)+"</td><td>"+rs.getString(5)+"</td></tr>";
			
					
				}
				ret+="</tbody></table></div></center><br/><hr style='color:black;width:80%;' /><br/>" +
				"<center><b>Parole Register</b><img onclick='if(this.getAttribute(src1)==loc1){this.setAttribute(src1,loc);}else{this.setAttribute(src1,loc1);}hider(rep_tab13)' src='images/arrow-right1.gif' style='height:15;width:15;margin-left:20px;cursor:pointer;' /></center>" +
		"<center><div class='rep_tab13'><table border='2' bit='0' id='rep_tab13' style='margin-top:10px;width:85%;border-collapse:collapse;color:#a00000;'><tbody>" +
		"<tr><th style='background-image:url(images/header_bg2.png);'>Prisoner Id</th><th style='background-image:url(images/header_bg2.png);'>Out Date</th><th style='background-image:url(images/header_bg2.png);'>Reason</th><th style='background-image:url(images/header_bg2.png);'>In Date</th><th style='background-image:url(images/header_bg2.png);'>Police Accomdated</th></tr>";
		i=0;
		stmt=conn.prepareStatement("select id,outdate,reason,indate,polaccom from sch1.parole_reg where jno=? and year(indate)="+year1+" and month(indate)="+month);
		stmt.setString(1,jno);
		
						
		rs=stmt.executeQuery();
		while(rs.next())
		{
			i++;
			if(i%2==1)
				ret+="<tr class='rep_tab3' style='background-color:#f0f7f9'><td>"+rs.getString(1)+"</td><td>"+rs.getString(2)+"</td><td>"+rs.getString(3)+"</td><td>"+rs.getString(4)+"</td><td>"+rs.getString(5)+"</td></tr>";
			else
				ret+="<tr class='rep_tab3' style='background-color:#f0f7a6'><td>"+rs.getString(1)+"</td><td>"+rs.getString(2)+"</td><td>"+rs.getString(3)+"</td><td>"+rs.getString(4)+"</td><td>"+rs.getString(5)+"</td></tr>";
	
			
		}
		
		ret+="</tbody></table></div></center><br/><hr style='color:black;width:80%;' /><br/>" +
		"<center><b>Staff Register</b><img onclick='if(this.getAttribute(src1)==loc1){this.setAttribute(src1,loc);}else{this.setAttribute(src1,loc1);}hider(rep_tab14)' src='images/arrow-right1.gif' style='height:15;width:15;margin-left:29px;cursor:pointer;' /></center>" +
"<center><div class='rep_tab14'><table border='2' bit='0' id='rep_tab14' style='margin-top:10px;width:85%;border-collapse:collapse;color:#a00000;'><tbody>" +
"<tr><th style='background-image:url(images/header_bg2.png);'>Staff Id</th><th style='background-image:url(images/header_bg2.png);'>Name</th><th style='background-image:url(images/header_bg2.png);'>Category</th><th style='background-image:url(images/header_bg2.png);'>Address</th></tr>";
i=0;
stmt=conn.prepareStatement("select id,name,category,Address from sch1.staff1 where jno=?");
stmt.setString(1,jno);

				
rs=stmt.executeQuery();
while(rs.next())
{
	i++;
	if(i%2==1)
		ret+="<tr class='rep_tab3' style='background-color:#f0f7a6'><td>"+rs.getString(1)+"</td><td>"+rs.getString(2)+"</td><td>"+rs.getString(3)+"</td><td>"+rs.getString(4)+"</td></tr>";
	else
		ret+="<tr class='rep_tab3' style='background-color:#f0f7f9'><td>"+rs.getString(1)+"</td><td>"+rs.getString(2)+"</td><td>"+rs.getString(3)+"</td><td>"+rs.getString(4)+"</td></tr>";

	
}
ret+="</tbody></table></div></center><br/><hr style='color:black;width:80%;' /><br/>" +
"<center><b>Fund-In Register</b><img onclick='if(this.getAttribute(src1)==loc1){this.setAttribute(src1,loc);}else{this.setAttribute(src1,loc1);}hider(rep_tab15)' src='images/arrow-right1.gif' style='height:15;width:15;margin-left:20px;cursor:pointer;' /></center>" +
"<center><div class='rep_tab15'><table border='2' bit='0' id='rep_tab15' style='margin-top:10px;width:85%;border-collapse:collapse;color:#a00000;'><tbody>" +
"<tr><th style='background-image:url(images/header_bg2.png);'>Date</th><th style='background-image:url(images/header_bg2.png);'>Time</th><th style='background-image:url(images/header_bg2.png);'>Amount</th></tr>";
i=0;

Calendar c=Calendar.getInstance();
Integer year=c.get(Calendar.YEAR);
int temp1=0;

stmt=conn.prepareStatement("select date,time,amount from sch1.fund_in where jno=? and finyear="+year1+" and month(date)="+month);
stmt.setString(1,jno);
//stmt.setString(2,year.toString());

		
rs=stmt.executeQuery();
while(rs.next())
{
i++;
if(i%2==1)
ret+="<tr class='rep_tab3' style='background-color:#f0f7f9'><td>"+rs.getString(1)+"</td><td>"+rs.getString(2)+"</td><td>"+rs.getString(3)+" Rs</td></tr>";
else
ret+="<tr class='rep_tab4' style='background-color:#f0f7a6'><td>"+rs.getString(1)+"</td><td>"+rs.getString(2)+"</td><td>"+rs.getString(3)+" Rs</td></tr>";


}





ret+="</tbody></table></div></center><br/><hr style='color:black;width:80%;' /><br/>" +
"<center><b>Fund-Out Register</b><img onclick='if(this.getAttribute(src1)==loc1){this.setAttribute(src1,loc);}else{this.setAttribute(src1,loc1);}hider(rep_tab16)' src='images/arrow-right1.gif' style='height:15;width:15;margin-left:15px;cursor:pointer;' /></center>" +
"<center><div class='rep_tab16'><table border='2' bit='0' id='rep_tab16' style='margin-top:10px;width:85%;border-collapse:collapse;color:#a00000;'><tbody>" +
"<tr><th style='background-image:url(images/header_bg2.png);'>Date</th><th style='background-image:url(images/header_bg2.png);'>Time</th><th style='background-image:url(images/header_bg2.png);'>Reason</th><th style='background-image:url(images/header_bg2.png);'>Amount</th></tr>";
i=0;

 c=Calendar.getInstance();
 year=c.get(Calendar.YEAR);
 temp1=0;

stmt=conn.prepareStatement("select date,time,reason,amount from sch1.fund_out where jno=? and finyear="+year1+" and month(date)="+month);
stmt.setString(1,jno);
//stmt.setString(2,year.toString());

		
rs=stmt.executeQuery();
while(rs.next())
{
i++;
if(i%2==1)
ret+="<tr class='rep_tab3' style='background-color:#f0f7f9'><td>"+rs.getString(1)+"</td><td>"+rs.getString(2)+"</td><td>"+rs.getString(3)+"</td><td>"+rs.getString(4)+" rs</td></tr>";
else
ret+="<tr class='rep_tab4' style='background-color:#f0f7a6'><td>"+rs.getString(1)+"</td><td>"+rs.getString(2)+"</td><td>"+rs.getString(3)+"</td><td>"+rs.getString(4)+" rs</td></tr>";


}



stmt=conn.prepareStatement("select sum(amount) from sch1.fund_in where jno=? and finyear="+year1+" and month(date)="+month);
stmt.setString(1,jno);
//stmt.setString(2,year.toString());

		
rs=stmt.executeQuery();
while(rs.next())
{
	temp1=rs.getInt(1);
ret+="<tr class='rep_tab3' style='background-color:#f0f7f9'><td><b>Total Fund-In In This Year:</b>"+temp1+"</td>";


}
stmt=conn.prepareStatement("select sum(amount) from sch1.fund_out where jno=? and finyear="+year1+" and month(date)="+month);
stmt.setString(1,jno);
//stmt.setString(2,year.toString());

		
rs=stmt.executeQuery();
while(rs.next())
{
	int temp2=rs.getInt(1);
ret+="<td><b>Total Fund-Out In This Year:</b>"+temp2+"</td><td><b>Fund Remaining In Treasury:</b>"+(temp1-temp2)+"</td></tr>";


}


ret+="</tbody></table><br/><br/></div></center>";

				ret=ret.replaceAll("null","");
				
				if(ret!=null)
					return ret;
				//else
					//return "No Staff is Inside";
				
			}
			else
			{
				return "false";
			}
			
			}catch(Exception e){return "We Are Facing Error With Our Database Server.<br/>Sorry For The Inconvineance.";}
			finally{
				try {
					conn.close();
				} catch (SQLException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}

		return null;
		

	}

	
	
	
	
	
	
	
	
	
	public String returnRecord(String jno) {
		jno=queryValidate(jno);
		int i=0;
		
		// TODO Auto-generated method stub
		String ret="<div id='info_abt_reg' style='z-index:10;height:40px;width:40px;background-color:black;display:none;'></div><center>" +
				"" +
				"<center><b>Interview Register&nbsp;&nbsp;&nbsp;</b><img onclick='if(this.getAttribute(src1)==loc1)this.setAttribute(src1,loc);else{this.setAttribute(src1,loc1);}hider(rep_tab11)' src='images/arrow-right1.gif' style='height:15;width:15;margin-left:-1px;cursor:pointer;' /></center>" +
				"<center><div class='rep_tab11'><table border='2' id='rep_tab11' bit='0' style='width:85%;border-collapse:collapse;color:#a00000;margin-top:10px;'><tbody>" +
				"" +
				" <tr><th style='background-image:url(images/header_bg2.png);'>Name</th><th style='background-image:url(images/header_bg2.png);'>Address</th><th style='background-image:url(images/header_bg2.png);'>Interview Date</th><th style='background-image:url(images/header_bg2.png);'>Prisoner</th><th style='background-image:url(images/header_bg2.png);'>Relation</th><th style='background-image:url(images/header_bg2.png);'>Accept Status</th></tr>";
		//int i=0;
		try{
			conn = DriverManager.getConnection("jdbc:db2://localhost:50000/PRISIONM:retrieveMessagesFromServerOnGetMessage=true;","inst","sister");
			
			if(failure==false)
			{
				stmt=conn.prepareStatement("select name,address,idate,pid,relation,allowed from sch1.interview_register where jno=? and year(idate)=year(Current date)");
				stmt.setString(1,jno);
				
								
				ResultSet rs=stmt.executeQuery();
				while(rs.next())
				{	
					i++;
					if(i%2==1)
						ret+="<tr class='rep_tab1' style='background-color:#f0f7f9'><td>"+rs.getString(1)+"</td><td>"+rs.getString(2)+"</td><td>"+rs.getString(3)+"</td><td>"+rs.getString(4)+"</td><td>"+rs.getString(5)+"</td><td>"+rs.getString(6)+"</td></tr>";
					else
						ret+="<tr class='rep_tab1' style='background-color:#f0f7a6'><td>"+rs.getString(1)+"</td><td>"+rs.getString(2)+"</td><td>"+rs.getString(3)+"</td><td>"+rs.getString(4)+"</td><td>"+rs.getString(5)+"</td><td>"+rs.getString(6)+"</td></tr>";
				}
				i=0;
				ret+="</tbody></table></div></center><br/><hr style='color:black;width:80%;' /><br/>" +
				"<center><b>Duty Register&nbsp;</b><img onclick='if(this.getAttribute(src1)==loc1)this.setAttribute(src1,loc);else{this.setAttribute(src1,loc1);}hider(rep_tab12)' src='images/arrow-right1.gif' style='height:15;width:15;margin-left:20px;cursor:pointer;' /></center>" +
				"<center><div class='rep_tab12'><table bit='0' id='rep_tab12' border='2' style='margin-top:10px;width:85%;margin-left:10px;margin-right:10px;border-collapse:collapse;color:#a00000;'><tbody>" +
				"<tr><th style='background-image:url(images/header_bg2.png);'>Staff Id</th><th style='background-image:url(images/header_bg2.png);'>Date</th><th style='background-image:url(images/header_bg2.png);'>Shift</th><th style='background-image:url(images/header_bg2.png);'>Block</th><th style='background-image:url(images/header_bg2.png);'>Reason</th></tr>";
				
				stmt=conn.prepareStatement("select staffid,date,shift,block,reason from sch1.duty_register where jno=? and year(date)=year(Current date)");
				stmt.setString(1,jno);
				
								
				 rs=stmt.executeQuery();
				while(rs.next())
				{
					i++;
					if(i%2==1)
						ret+="<tr class='rep_tab2' style='background-color:#F0F7a6'><td>"+rs.getString(1)+"</td><td>"+rs.getString(2)+"</td><td>"+rs.getString(3)+"</td><td>"+rs.getString(4)+"</td><td>"+rs.getString(5)+"</td></tr>";
					else
						ret+="<tr class='rep_tab2' style='background-color:#F0F7f9'><td>"+rs.getString(1)+"</td><td>"+rs.getString(2)+"</td><td>"+rs.getString(3)+"</td><td>"+rs.getString(4)+"</td><td>"+rs.getString(5)+"</td></tr>";
			
					
				}
				ret+="</tbody></table></div></center><br/><hr style='color:black;width:80%;' /><br/>" +
				"<center><b>Parole Register</b><img onclick='if(this.getAttribute(src1)==loc1){this.setAttribute(src1,loc);}else{this.setAttribute(src1,loc1);}hider(rep_tab13)' src='images/arrow-right1.gif' style='height:15;width:15;margin-left:20px;cursor:pointer;' /></center>" +
		"<center><div class='rep_tab13'><table border='2' bit='0' id='rep_tab13' style='margin-top:10px;width:85%;border-collapse:collapse;color:#a00000;'><tbody>" +
		"<tr><th style='background-image:url(images/header_bg2.png);'>Prisoner Id</th><th style='background-image:url(images/header_bg2.png);'>Out Date</th><th style='background-image:url(images/header_bg2.png);'>Reason</th><th style='background-image:url(images/header_bg2.png);'>In Date</th><th style='background-image:url(images/header_bg2.png);'>Police Accomdated</th></tr>";
		i=0;
		stmt=conn.prepareStatement("select id,outdate,reason,indate,polaccom from sch1.parole_reg where jno=? and year(indate)=year(Current date)");
		stmt.setString(1,jno);
		
						
		rs=stmt.executeQuery();
		while(rs.next())
		{
			i++;
			if(i%2==1)
				ret+="<tr class='rep_tab3' style='background-color:#f0f7f9'><td>"+rs.getString(1)+"</td><td>"+rs.getString(2)+"</td><td>"+rs.getString(3)+"</td><td>"+rs.getString(4)+"</td><td>"+rs.getString(5)+"</td></tr>";
			else
				ret+="<tr class='rep_tab3' style='background-color:#f0f7a6'><td>"+rs.getString(1)+"</td><td>"+rs.getString(2)+"</td><td>"+rs.getString(3)+"</td><td>"+rs.getString(4)+"</td><td>"+rs.getString(5)+"</td></tr>";
	
			
		}
		
		ret+="</tbody></table></div></center><br/><hr style='color:black;width:80%;' /><br/>" +
		"<center><b>Staff Register</b><img onclick='if(this.getAttribute(src1)==loc1){this.setAttribute(src1,loc);}else{this.setAttribute(src1,loc1);}hider(rep_tab14)' src='images/arrow-right1.gif' style='height:15;width:15;margin-left:29px;cursor:pointer;' /></center>" +
"<center><div class='rep_tab14'><table border='2' bit='0' id='rep_tab14' style='margin-top:10px;width:85%;border-collapse:collapse;color:#a00000;'><tbody>" +
"<tr><th style='background-image:url(images/header_bg2.png);'>Staff Id</th><th style='background-image:url(images/header_bg2.png);'>Name</th><th style='background-image:url(images/header_bg2.png);'>Category</th><th style='background-image:url(images/header_bg2.png);'>Address</th></tr>";
i=0;
stmt=conn.prepareStatement("select id,name,category,Address from sch1.staff1 where jno=?");
stmt.setString(1,jno);

				
rs=stmt.executeQuery();
while(rs.next())
{
	i++;
	if(i%2==1)
		ret+="<tr class='rep_tab3' style='background-color:#f0f7a6'><td>"+rs.getString(1)+"</td><td>"+rs.getString(2)+"</td><td>"+rs.getString(3)+"</td><td>"+rs.getString(4)+"</td></tr>";
	else
		ret+="<tr class='rep_tab3' style='background-color:#f0f7f9'><td>"+rs.getString(1)+"</td><td>"+rs.getString(2)+"</td><td>"+rs.getString(3)+"</td><td>"+rs.getString(4)+"</td></tr>";

	
}
ret+="</tbody></table></div></center><br/><hr style='color:black;width:80%;' /><br/>" +
"<center><b>Fund-In Register</b><img onclick='if(this.getAttribute(src1)==loc1){this.setAttribute(src1,loc);}else{this.setAttribute(src1,loc1);}hider(rep_tab15)' src='images/arrow-right1.gif' style='height:15;width:15;margin-left:20px;cursor:pointer;' /></center>" +
"<center><div class='rep_tab15'><table border='2' bit='0' id='rep_tab15' style='margin-top:10px;width:85%;border-collapse:collapse;color:#a00000;'><tbody>" +
"<tr><th style='background-image:url(images/header_bg2.png);'>Date</th><th style='background-image:url(images/header_bg2.png);'>Time</th><th style='background-image:url(images/header_bg2.png);'>Amount</th></tr>";
i=0;

Calendar c=Calendar.getInstance();
Integer year=c.get(Calendar.YEAR);
int temp1=0;

stmt=conn.prepareStatement("select date,time,amount from sch1.fund_in where jno=? and finyear=?");
stmt.setString(1,jno);
stmt.setString(2,year.toString());

		
rs=stmt.executeQuery();
while(rs.next())
{
i++;
if(i%2==1)
ret+="<tr class='rep_tab3' style='background-color:#f0f7f9'><td>"+rs.getString(1)+"</td><td>"+rs.getString(2)+"</td><td>"+rs.getString(3)+" Rs</td></tr>";
else
ret+="<tr class='rep_tab4' style='background-color:#f0f7a6'><td>"+rs.getString(1)+"</td><td>"+rs.getString(2)+"</td><td>"+rs.getString(3)+" Rs</td></tr>";


}





ret+="</tbody></table></div></center><br/><hr style='color:black;width:80%;' /><br/>" +
"<center><b>Fund-Out Register</b><img onclick='if(this.getAttribute(src1)==loc1){this.setAttribute(src1,loc);}else{this.setAttribute(src1,loc1);}hider(rep_tab16)' src='images/arrow-right1.gif' style='height:15;width:15;margin-left:15px;cursor:pointer;' /></center>" +
"<center><div class='rep_tab16'><table border='2' bit='0' id='rep_tab16' style='margin-top:10px;width:85%;border-collapse:collapse;color:#a00000;'><tbody>" +
"<tr><th style='background-image:url(images/header_bg2.png);'>Date</th><th style='background-image:url(images/header_bg2.png);'>Time</th><th style='background-image:url(images/header_bg2.png);'>Reason</th><th style='background-image:url(images/header_bg2.png);'>Amount</th></tr>";
i=0;

 c=Calendar.getInstance();
 year=c.get(Calendar.YEAR);
 temp1=0;

stmt=conn.prepareStatement("select date,time,reason,amount from sch1.fund_out where jno=? and finyear=?");
stmt.setString(1,jno);
stmt.setString(2,year.toString());

		
rs=stmt.executeQuery();
while(rs.next())
{
i++;
if(i%2==1)
ret+="<tr class='rep_tab3' style='background-color:#f0f7f9'><td>"+rs.getString(1)+"</td><td>"+rs.getString(2)+"</td><td>"+rs.getString(3)+"</td><td>"+rs.getString(4)+" rs</td></tr>";
else
ret+="<tr class='rep_tab4' style='background-color:#f0f7a6'><td>"+rs.getString(1)+"</td><td>"+rs.getString(2)+"</td><td>"+rs.getString(3)+"</td><td>"+rs.getString(4)+" rs</td></tr>";


}



stmt=conn.prepareStatement("select sum(amount) from sch1.fund_in where jno=? and finyear=?");
stmt.setString(1,jno);
stmt.setString(2,year.toString());

		
rs=stmt.executeQuery();
while(rs.next())
{
	temp1=rs.getInt(1);
ret+="<tr class='rep_tab3' style='background-color:#f0f7f9'><td><b>Total Fund-In In This Year:</b>"+temp1+"</td>";


}
stmt=conn.prepareStatement("select sum(amount) from sch1.fund_out where jno=? and finyear=?");
stmt.setString(1,jno);
stmt.setString(2,year.toString());

		
rs=stmt.executeQuery();
while(rs.next())
{
	int temp2=rs.getInt(1);
ret+="<td><b>Total Fund-Out In This Year:</b>"+temp2+"</td><td><b>Fund Remaining In Treasury:</b>"+(temp1-temp2)+"</td></tr>";


}


ret+="</tbody></table><br/><br/></div></center>";

				ret=ret.replaceAll("null","");
				
				if(ret!=null)
					return ret;
				//else
					//return "No Staff is Inside";
				
			}
			else
			{
				return "false";
			}
			
			}catch(Exception e){return "We Are Facing Error With Our Database Server.<br/>Sorry For The Inconvineance.";}
			finally{
				try {
					conn.close();
				} catch (SQLException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}

		return null;
		

	}

	public String returnRecord1(String jno, String date) {
		// TODO Auto-generated method stub
		return null;
	}

	public String addFundIn(String jno,String indate,String amount) {
		jno=queryValidate(jno);
		indate=queryValidate(indate);
		amount=queryValidate(amount);
		// TODO Auto-generated method stub
try{		
	conn = DriverManager.getConnection("jdbc:db2://localhost:50000/PRISIONM:retrieveMessagesFromServerOnGetMessage=true;","inst","sister");
	
	int amt=Integer.parseInt(amount);
	stmt=conn.prepareStatement("insert into sch1.fund_in values(?,Current Date,Current Time,?,?)");
	stmt.setString(1,jno);
	stmt.setInt(2, amt);
	Calendar c=Calendar.getInstance();
	int finyear=c.get(Calendar.YEAR);
	stmt.setInt(3, finyear);
	int no=stmt.executeUpdate();
	if(no>=1)
	return "true";
	else
	return "Fund In May Be Wrongly Entered";	
}
catch(Exception e)
{
	return "<b><font color='black'>ERROR:Causes May Be,</font></b><br/><span style='font-weight:none;'>1.&nbsp;Fund In Entered May Be Incorrect <br/> 2.&nbsp;There May Be Error With Our DataBase<br/> Server</span>";
}
finally{
	try {
		conn.close();
	} catch (SQLException e) {
		// TODO Auto-generated catch block
		e.printStackTrace();
	}
}
}


	

	public String addDutyReg(String jno, String id, String shiftid, String block,String reason) {
		// TODO Auto-generated method stub
		boolean x=false;
		jno=queryValidate(jno);
		id=queryValidate(id);
		shiftid=queryValidate(shiftid);
		block=queryValidate(block);
		reason=queryValidate(reason);
		
		try{		
			conn = DriverManager.getConnection("jdbc:db2://localhost:50000/PRISIONM:retrieveMessagesFromServerOnGetMessage=true;","inst","sister");
			
			stmt=conn.prepareStatement("select id from sch1.staff1 where jno=?");
			stmt.setString(1, jno);
			ResultSet rs=stmt.executeQuery();
			while(rs.next())
			{
				if(id.equals(rs.getString(1)))
				{
			x=true;	 
				}
			}
			if(x)
			{
			stmt=conn.prepareStatement("insert into sch1.duty_register values(?,?,Current Date,?,?,?)");
			stmt.setString(1,jno);
			stmt.setString(2, id);
			stmt.setString(3, shiftid);
			stmt.setString(4, block);
			stmt.setString(5, reason);
			int no=stmt.executeUpdate();
			if(no>=1)
			return "true";
			}
			else
				return "nostaff";
		}
		catch(Exception e)
		{
			//return e.toString();
			return "<b><font color='black'>ERROR:Causes May Be,</font></b><br/><span style='font-weight:none;'>There May Be Error With Our DataBase<br/> Server<br/></span>";
		}
		finally{
			try {
				conn.close();
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		return null;
		
	}

	public String getAmount(String jno) {
		// TODO Auto-generated method stub
		jno=queryValidate(jno);
		String ret=null;
		try{
			conn = DriverManager.getConnection("jdbc:db2://localhost:50000/PRISIONM:retrieveMessagesFromServerOnGetMessage=true;","inst","sister");
			
			int temp_amt;
			stmt=conn.prepareStatement("select sum(amount) from sch1.fund_in where jno=?");
			stmt.setString(1,jno);
			ResultSet rs=stmt.executeQuery();
			if(rs.next())
			{
             temp_amt=rs.getInt(1);				
					
			stmt=conn.prepareStatement("select sum(amount) from sch1.fund_out where jno=?");
			stmt.setString(1,jno);
			rs=stmt.executeQuery();
			if(rs.next())
				temp_amt-=rs.getInt(1);
			
			if(temp_amt>0)
			{
			
			
			
			
			ret="<input name='text1' type='text' value='"+temp_amt+"'size=20 onfocus='foc_entry1();' />";
			return ret;
						
			
				
		}
			else 
				return "not enough";	
			}
			else
				return "Fund In details not Present";
		}
		catch(Exception e)
		{
			return "<b><font color='black'>ERROR:Causes May Be,</font></b><br/><span style='font-weight:none;'>1.&nbsp;There May Be Error With Our DataBase<br/> Server</span>";
		}
		finally{
			try {
				conn.close();
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}

	}

	public String addFundOut(String jno, String amount,String reason) {
		// TODO Auto-generated method stub
		jno=queryValidate(jno);
		amount=queryValidate(amount);
		reason=queryValidate(reason);
		
		try{		
			conn = DriverManager.getConnection("jdbc:db2://localhost:50000/PRISIONM:retrieveMessagesFromServerOnGetMessage=true;","inst","sister");
			
			int amt=Integer.parseInt(amount);
			
			int temp_amt;
			stmt=conn.prepareStatement("select sum(amount) from sch1.fund_in where jno=?");
			stmt.setString(1,jno);
			ResultSet rs=stmt.executeQuery();
			if(rs.next())
			{
             temp_amt=rs.getInt(1);				
					
			stmt=conn.prepareStatement("select sum(amount) from sch1.fund_out where jno=?");
			stmt.setString(1,jno);
			rs=stmt.executeQuery();
			if(rs.next())
				temp_amt-=rs.getInt(1);
			
			if(amt<=0)
			return "Enter Valid Amount";
			if(amt<=temp_amt)
			{
			
			
			
			stmt=conn.prepareStatement("insert into sch1.fund_Out values(?,Current Date,Current Time,?,?,?)");
			stmt.setString(1,jno);
			stmt.setString(2, reason);
			stmt.setInt(3, Integer.parseInt(amount));
			Calendar c=Calendar.getInstance();
			int finyear=c.get(Calendar.YEAR);
			stmt.setInt(4, finyear);
			int no=stmt.executeUpdate();
			if(no>=1)
			return "true";
			else
			return "Fund In May Be Wrongly Entered";	
		
			}
			else 
			{
				return (new Integer(temp_amt)).toString();
			}
			}
			else
			{
				return "No Chance To Get This";
			}
		}
			
		catch(Exception e)
		{
			return "<b><font color='black'>ERROR:Causes May Be,</font></b><br/><span style='font-weight:none;'>1.&nbsp;Details Entered May Be Incorrect <br/> 2.&nbsp;There May Be Error With Our DataBase<br/> Server</span>";
		}
		finally{
			try {
				conn.close();
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		
		
	}

	public String addPrisoner(String id, String name, String fname,String date,String iris,String nation,String city,String state)  {
		id=queryValidate(id);
		name=queryValidate(name);
		fname=queryValidate(fname);
		date=queryValidate(date);
		iris=queryValidate(iris);
		nation=queryValidate(nation);
		city=queryValidate(city);
		state=queryValidate(state);
		boolean in_or_not=false;
		try{
			conn = DriverManager.getConnection("jdbc:db2://localhost:50000/PRISIONM:retrieveMessagesFromServerOnGetMessage=true;","inst","sister");
			
			if(failure==false)
			{
				stmt=conn.prepareStatement("select pid from sch1.prisoner_bio");
				ResultSet rs=stmt.executeQuery();
			while(rs.next())
			{
					if(id.equals(rs.getString(1)))
					{
					in_or_not=true;	
					break;
					}
			}	
				
				if(!in_or_not)
				{
				stmt=conn.prepareStatement("insert into sch1.prisoner_bio(pid,pname,fname,pdob,isinjail,isalive,iriscolor,nationality,city,state) values(?,?,?,?,?,?,?,?,?,?)");
				stmt.setString(1,id);
				stmt.setString(2,name);
				stmt.setString(3,fname);
				stmt.setString(4,date);
				stmt.setString(5,"y");
				stmt.setString(6,"y");
				stmt.setString(7,iris);
				stmt.setString(8,nation);
				stmt.setString(9,city);
				stmt.setString(10,state);
				int no=stmt.executeUpdate();
					if(no>=1)
						return "true";
					else
						return "Details May Be Wrongly Entered";
				}
				else
				{
					return "alreadyin";
				}
			}
			else
			{
				return "false";
			}
			
			}catch(Exception e){
				if((e.toString()).indexOf("datetime")!=-1)
					return "<b><font color='black'>ERROR:Causes May Be,</font></b><br/><span style='font-weight:none;'>1.&nbsp;There May Be Error With Our DataBase<br/> Server</span><br/>2.&nbsp;Check Your Date Format ";
				else
					return "<b><font color='black'>ERROR:Causes May Be,</font></b><br/><span style='font-weight:none;'>1.&nbsp;There May Be Error With Our DataBase<br/> Server</span>";
			}
			finally{
				try {
					conn.close();
				} catch (SQLException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		//return "false";

		// TODO Auto-generated method stub
		//return null;
	}

	public String updatePrisoner(String jno, String pid, String fno,String caseno, String odate, String rem,String crime,String articles,String sentence) {
		jno=queryValidate(jno);
		pid=queryValidate(pid);
		fno=queryValidate(fno);
		caseno=queryValidate(caseno);
		odate=queryValidate(odate);
		rem=queryValidate(rem);
		crime=queryValidate(crime);
		articles=queryValidate(articles);
		sentence=queryValidate(sentence);
		
		boolean in_or_not=true;
		boolean anybody=false;
		boolean in_or_not2=false;
		ResultSet rs;
		try{
			conn = DriverManager.getConnection("jdbc:db2://localhost:50000/PRISIONM:retrieveMessagesFromServerOnGetMessage=true;","inst","sister");
			
			if(failure==false)
			{
				stmt=conn.prepareStatement("select pid from sch1.prisoner_bio ");
			 rs=stmt.executeQuery();
			while(rs.next())
			{
				anybody=true;
					if(pid.equals(rs.getString(1)))
					{
					in_or_not=false;	
					break;
							}
			}	
			if((in_or_not==false && anybody==true))
			{
			stmt=conn.prepareStatement("select pid from sch1.prisioner where reldate>current date ");
			ResultSet rs1=stmt.executeQuery();
		while(rs1.next())
		{
				if(pid.equals(rs1.getString(1)))
				{
				in_or_not2=true;	
				break;
						}
		} 
		if(in_or_not2)
		{
		return "already inside a jail";	
		}
		
					stmt=conn.prepareStatement("update sch1.prisoner_bio set isinjail='y' where pid=?");
					stmt.setString(1, pid);
					stmt.executeUpdate();
				stmt=conn.prepareStatement("insert into sch1.prisioner values(?,?,?,?,?,?,Current date,?,?,?,?)");
				stmt.setString(1,pid);
				stmt.setString(2,fno);
				stmt.setString(3,caseno);
				stmt.setString(4,jno);
				stmt.setString(5,odate);
				stmt.setString(6,rem);
				stmt.setString(7,crime);
				stmt.setString(8,articles);
				stmt.setString(9,sentence);			
				stmt.setString(10,"normal");
				int no=stmt.executeUpdate();
					if(no>=1)
						return "true";
					else
						return "Details May Be Wrongly Entered";
				}
				
			
			else if(in_or_not==true && anybody==true)
			{
				return "Given Prisoner Has No Old Records.";
			}
			else if(anybody==false){
				return "No Prisoner's Details Is Found For This Prison.";
			}
			else
				return "";
			}
			else
			{
				return "false";
			}
			
			}catch(Exception e){
				if((e.toString()).indexOf("datetime")!=-1)
					return "<b><font color='black'>ERROR:Causes May Be,</font></b><br/><span style='font-weight:none;'>1.&nbsp;There May Be Error With Our DataBase<br/> Server</span><br/>2.&nbsp;Check Your Date Format ";
				else
					return "<b><font color='black'>ERROR:Causes May Be,</font></b><br/><span style='font-weight:none;'>1.&nbsp;There May Be Error With Our DataBase<br/> Server</span>";
			}
			finally{
				try {
					conn.close();
				} catch (SQLException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		//return "false";

		// TODO Auto-generated method stub
		//return null;
	}



	public String addInterview(String jno, String addr, String pid,String Relation, String name,String yesorno) {
		jno=queryValidate(jno);
		addr=queryValidate(addr);
		pid=queryValidate(pid);
		Relation=queryValidate(Relation);
		name=queryValidate(name);
		yesorno=queryValidate(yesorno);
		boolean in_or_not=false;
		try{
			conn = DriverManager.getConnection("jdbc:db2://localhost:50000/PRISIONM:retrieveMessagesFromServerOnGetMessage=true;","inst","sister");
			
			if(failure==false)
			{
				stmt=conn.prepareStatement("select pid from sch1.prisioner where  jno=? and reldate>Current date");
				stmt.setString(1, jno);
				ResultSet rs=stmt.executeQuery();
			while(rs.next())
			{
					if(pid.equals(rs.getString(1)))
					{
					in_or_not=true;	
					break;
							}
			}	
				
				if(in_or_not)
				{
				stmt=conn.prepareStatement("insert into sch1.interview_register values(?,?,Current Date,?,?,?,?)");
				stmt.setString(1,jno);
				stmt.setString(2,addr);
				stmt.setString(3,pid);
				stmt.setString(4,Relation);
				stmt.setString(5,yesorno);
				stmt.setString(6,name);
				int no=stmt.executeUpdate();
					if(no>=1)
						return "true";
					else
						return "Details May Be Wrongly Entered";
				}
				else
				{
					return "The Specified Prisoner Is Not Present In This Jail.";
				}
			}
			else
			{
				return "false";
			}
			
			}catch(Exception e){return "<b><font color='black'>ERROR:Causes May Be,</font></b><br/><span style='font-weight:none;'>1.&nbsp;There May Be Error With Our DataBase<br/> Server</span>";}
			finally{
				try {
					conn.close();
				} catch (SQLException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		//return "false";

		// TODO Auto-generated method stub
		//return null;
	}
	public String updateDutyReg(String jno,String staffid,String date,String shift,String block,String reason){
		jno=queryValidate(jno);
		staffid=queryValidate(staffid);
		block=queryValidate(block);
		date=queryValidate(date);
		shift=queryValidate(shift);
		reason=queryValidate(reason);
		
		boolean in_or_not=false;
		try{
			conn = DriverManager.getConnection("jdbc:db2://localhost:50000/PRISIONM:retrieveMessagesFromServerOnGetMessage=true;","inst","sister");
			
			if(failure==false)
			{
				stmt=conn.prepareStatement("select id from sch1.staff1 where id=? and jno=?");
				stmt.setString(1,staffid);
				stmt.setString(2,jno);
				ResultSet rs=stmt.executeQuery();
				if(rs.next())
				if(rs.getString(1).equals(staffid))
				{
					in_or_not=true;	
								}
				
				if(in_or_not)
				{
					PreparedStatement p = conn.prepareStatement("update sch1.duty_register set shift=?,block=?,reason=? where jno=? and staffid=? and date=?");
				    p.setString(1,shift);
				    p.setString(2, block);
				    p.setString(3, reason);
				    p.setString(4, jno);
				    p.setString(5, staffid); 
				    p.setString(6,date);
				   int no= p.executeUpdate();
					if(no>=1)
						return "true";
					else
						return "false";
				}
				else
				{
					return "notalreadyin";
				}
			}
			else
			{
				return "false";
			}
			
			}catch(Exception e){
				if((e.toString()).indexOf("datetime")!=-1)
					return "<b><font color='black'>ERROR:Causes May Be,</font></b><br/><span style='font-weight:none;'>1.&nbsp;There May Be Error With Our DataBase<br/> Server</span><br/>2.&nbsp;Check Your Date Format ";
				else
					return "<b><font color='black'>ERROR:Causes May Be,</font></b><br/><span style='font-weight:none;'>1.&nbsp;There May Be Error With Our DataBase<br/> Server</span>";
			}
			finally{
				try {
					conn.close();
				} catch (SQLException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
	}
public String updateFundIn(String jno,String date,String time,String amount){
	jno=queryValidate(jno);
	date=queryValidate(date);
	time=queryValidate(time);
	amount=queryValidate(amount);
	
	boolean in_or_not=false;
	try{
		conn = DriverManager.getConnection("jdbc:db2://localhost:50000/PRISIONM:retrieveMessagesFromServerOnGetMessage=true;","inst","sister");
		
		
				PreparedStatement p = conn.prepareStatement("update sch1.fund_in set amount=?,finyear=? where jno=? and date=? and time=?");
			    p.setInt(1,Integer.parseInt(amount));
			    //char c[]=date.toCharArray();
			    p.setInt(2,Integer.parseInt(date.substring(0,4)));
			    p.setString(3, jno);
			    p.setString(5, time);
			    p.setString(4,date);
			   int no= p.executeUpdate();
				if(no>=1)
					return "true";
				else
					return "false";
		
		}catch(Exception e){
			if((e.toString()).indexOf("datetime")!=-1)
				return "<b><font color='black'>ERROR:Causes May Be,</font></b><br/><span style='font-weight:none;'>1.&nbsp;There May Be Error With Our DataBase<br/> Server</span><br/>2.&nbsp;Check Your Date Format ";
			else
				return "<b><font color='black'>ERROR:Causes May Be,</font></b><br/><span style='font-weight:none;'>1.&nbsp;There May Be Error With Our DataBase<br/> Server</span>";
		}
		finally{
			try {
				conn.close();
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
}
public String updateFundOut(String jno,String date,String time,String reason,String amount){
	jno=queryValidate(jno);
	date=queryValidate(date);
	time=queryValidate(time);
	reason=queryValidate(reason);
	amount=queryValidate(amount);
	boolean in_or_not=false;
	try{
		conn = DriverManager.getConnection("jdbc:db2://localhost:50000/PRISIONM:retrieveMessagesFromServerOnGetMessage=true;","inst","sister");
		
		PreparedStatement p = conn.prepareStatement("update sch1.fund_out set amount=?,finyear=?,reason=? where jno=? and date=? and time=?");
	    p.setInt(1,Integer.parseInt(amount));
	    //char c[]=date.toCharArray();
	    p.setInt(2,Integer.parseInt(date.substring(0,3)));
	    p.setString(3, reason);
	    p.setString(4, jno);
	    p.setString(6, time);
	    p.setString(5,date);
	   int no= p.executeUpdate();
		if(no>=1)
					return "true";
				else
					return "false";
		
			
		}catch(Exception e){
			if((e.toString()).indexOf("datetime")!=-1)
				return "<b><font color='black'>ERROR:Causes May Be,</font></b><br/><span style='font-weight:none;'>1.&nbsp;There May Be Error With Our DataBase<br/> Server</span><br/>2.&nbsp;Check Your Date Format ";
			else
				return "<b><font color='black'>ERROR:Causes May Be,</font></b><br/><span style='font-weight:none;'>1.&nbsp;There May Be Error With Our DataBase<br/> Server</span>";
			}
		finally{
			try {
				conn.close();
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
}
public String updateInterview(String jno,String name,String addr,String pid,String relation,String allowed,String date){
	jno=queryValidate(jno);
	name=queryValidate(name);
	addr=queryValidate(addr);
	pid=queryValidate(pid);
	relation=queryValidate(relation);
	allowed=queryValidate(allowed);
	date=queryValidate(date);
	
	boolean in_or_not=false;
	try{
		conn = DriverManager.getConnection("jdbc:db2://localhost:50000/PRISIONM:retrieveMessagesFromServerOnGetMessage=true;","inst","sister");
		
		if(failure==false)
		{
			stmt=conn.prepareStatement("select pid from sch1.prisioner where jno=? and pid=?");
			stmt.setString(1,jno);
			stmt.setString(2,pid);
			ResultSet rs=stmt.executeQuery();
			if(rs.next())
			if(rs.getString(1).equals(pid))
			{
				in_or_not=true;	
							}
			
			if(in_or_not)
			{
					
				PreparedStatement p = conn.prepareStatement("update sch1.interview_register set relation=?,allowed=? where jno=? and address=? and pid=? and name=? and idate=?");
			    p.setString(1,relation);
			    p.setString(2, allowed);
			    p.setString(3, jno);
			    p.setString(4, addr);
			    p.setString(5,pid);
			    p.setString(6,name);
			    p.setString(7,date);
			   int no= p.executeUpdate();
				if(no>=1)
					return "true"; 
				else return "false";
			}
			else return "notalreadyin";
	
		
		}
		}catch(Exception e){
			if((e.toString()).indexOf("datetime")!=-1)
				return "<b><font color='black'>ERROR:Causes May Be,</font></b><br/><span style='font-weight:none;'>1.&nbsp;There May Be Error With Our DataBase<br/> Server</span><br/>2.&nbsp;Check Your Date Format ";
			else
				return "<b><font color='black'>ERROR:Causes May Be,</font></b><br/><span style='font-weight:none;'>1.&nbsp;There May Be Error With Our DataBase<br/> Server</span>";
			}
		finally{
			try {
				conn.close();
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
	return null;
}


public String updateParole(String jno,String id,String reason,String police,String out,String exp,String ret){
	jno=queryValidate(jno);
	reason=queryValidate(reason);
	police=queryValidate(police);
	out=queryValidate(out);
	ret=queryValidate(ret);
	exp=queryValidate(exp);
	
	boolean in_or_not=false;
	try{
		conn = DriverManager.getConnection("jdbc:db2://localhost:50000/PRISIONM:retrieveMessagesFromServerOnGetMessage=true;","inst","sister");
		
		if(failure==false)
		{
		 	stmt=conn.prepareStatement("select pid from sch1.prisioner where jno=?");
			stmt.setString(1,jno);
			ResultSet rs=stmt.executeQuery();
			while(rs.next())
			{
				in_or_not=true;	
							}
			
			if(in_or_not)
			{
				PreparedStatement p = conn.prepareStatement("update sch1.parole_reg set expindate=?,polaccom=?,reason=?,indate=? where id=? and jno=? and outdate=?");
			    p.setString(1,exp);
			    p.setString(2, police);
			    p.setString(3, reason);
			    p.setString(4, ret);
			    p.setString(5,id);
			    p.setString(6,jno);
			    p.setString(7,out);
			   int no= p.executeUpdate();
				if(no>=1)
					return "true";
				else
					return "false";
			}
			else
			{
				return "notalreadyin";
			}
		}
		else
		{
			return "false";
		}
		
		}catch(Exception e){
			if((e.toString()).indexOf("datetime")!=-1)
				return "<b><font color='black'>ERROR:Causes May Be,</font></b><br/><span style='font-weight:none;'>1.&nbsp;There May Be Error With Our DataBase<br/> Server</span><br/>2.&nbsp;Check Your Date Format ";
			else
				return "<b><font color='black'>ERROR:Causes May Be,</font></b><br/><span style='font-weight:none;'>1.&nbsp;There May Be Error With Our DataBase<br/> Server</span>";
			}
		finally{
			try {
				conn.close();
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
}
public String updateBio(String id,String isinjail,String isalive){
	id=queryValidate(id);
	isinjail=queryValidate(isinjail);
	isalive=queryValidate(isalive);
	boolean in_or_not=false;
	try{
		conn = DriverManager.getConnection("jdbc:db2://localhost:50000/PRISIONM:retrieveMessagesFromServerOnGetMessage=true;","inst","sister");
		
		if(failure==false)
		{
			stmt=conn.prepareStatement("select pid from sch1.prisoner_bio where pid=?");
			stmt.setString(1,id);
			ResultSet rs=stmt.executeQuery();
			if(rs.next())
			{
				in_or_not=true;	
							}
			
			if(in_or_not)
			{
				PreparedStatement p = conn.prepareStatement("update sch1.prisoner_bio set isinjail=?,isalive=? where pid=?");
			    p.setString(1, isinjail);
			    p.setString(2, isalive);
			    p.setString(3,id);
			    int no= p.executeUpdate();
				if(no>=1)
					return "true";
				else
					return "false";
			}
			else
			{
				return "notalreadyin";
			}
		}
		else
		{
			return "false";
		}
		
		}catch(Exception e){return "<b><font color='black'>ERROR:Causes May Be,</font></b><br/><span style='font-weight:none;'>&nbsp;1.Details Entered May Be Incorrect <br/> 2.&nbsp;There May Be Error With Our DataBase<br/>"+" Server</span>";}
		finally{
			try {
				conn.close();
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
}
public String queryValidate(String check_string)
{
	check_string= check_string.replaceAll("<", " ");
 	return check_string.replaceAll(">", " ");
}
public String updatePrisonerReg(String jno,String pid,String date,String sentence,String reason){
	boolean in_or_not=false;
	jno=queryValidate(jno);
	pid=queryValidate(pid);
	date=queryValidate(date);
	sentence=queryValidate(sentence);
	reason=queryValidate(reason);
	try{
		conn = DriverManager.getConnection("jdbc:db2://localhost:50000/PRISIONM:retrieveMessagesFromServerOnGetMessage=true;","inst","sister");
		
		if(failure==false)
		{
			
				stmt=conn.prepareStatement("select * from sch1.prisioner where pid=? and jno=? and reldate>Current date");
				stmt.setString(1,pid);
				stmt.setString(2,jno);
				ResultSet rs=stmt.executeQuery();
				if(rs.next())
				{
					in_or_not=true;	
			}
			
			if(in_or_not)
			{
		
				PreparedStatement p = conn.prepareStatement("update sch1.prisioner set reldate=?,sentence=?,reason=? where jno=? and pid=? and reldate>Current date");
			   
			    //char c[]=date.toCharArray();
			    p.setString(1,date);
			    p.setString(2,sentence);
			    p.setString(3, reason);
			    p.setString(4,jno);
			    p.setString(5,pid);
			     int no= p.executeUpdate();
				if(no>=1)
					return "true";
				else
					return "false";
			}
			else
			{
				return "notalreadyin";
			}
		}
		else
		{
			return "false";
		}
		}catch(Exception e){
			if((e.toString()).indexOf("datetime")!=-1)
				return "<b><font color='black'>ERROR:Causes May Be,</font></b><br/><span style='font-weight:none;'>1.&nbsp;There May Be Error With Our DataBase<br/> Server</span><br/>2.&nbsp;Check Your Date Format ";
			else
				return "<b><font color='black'>ERROR:Causes May Be,</font></b><br/><span style='font-weight:none;'>1.&nbsp;There May Be Error With Our DataBase<br/> Server</span>";
			}
		finally{
			try {
				conn.close();
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}

}



public String getStaff(String jno) {
	String ret=null;
	jno=queryValidate(jno);
	//int i=0;
	try{
		conn = DriverManager.getConnection("jdbc:db2://localhost:50000/PRISIONM:retrieveMessagesFromServerOnGetMessage=true;","inst","sister");
		if(failure==false) 
		{
			stmt=conn.prepareStatement("select id,name,category from sch1.staff1 where jno=?");
			stmt.setString(1,jno);
			ResultSet rs=stmt.executeQuery();
			while(rs.next())
			{	String abcd=rs.getString(1);
				ret+="<option attr='"+abcd+"'>"+abcd+"--"+rs.getString(2)+"--"+rs.getString(3)+"</option>";
				
			}
			if(ret!=null)
				return ret;
			else
				return "No Staff is Present in your Jail";
			
		}
		else
		{
			return null;
		}
		
		}catch(Exception e){return "<b><font color='black'>ERROR:Causes May Be,</font></b><br/><span style='font-weight:none;'>1.&nbsp;Details Entered May Be Incorrect <br/> 2.&nbsp;There May Be Error With Our DataBase<br/> Server</span>";}
		finally{
			try {
				conn.close();
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
}



public String deleteStaff(String jno, String id) {
	jno=queryValidate(jno);
	id=queryValidate(id);
	try{		
		conn = DriverManager.getConnection("jdbc:db2://localhost:50000/PRISIONM:retrieveMessagesFromServerOnGetMessage=true;","inst","sister");
		
		stmt=conn.prepareStatement("delete from sch1.staff1 where jno=? and id=?");
		stmt.setString(1,jno);
		stmt.setString(2, id);
		int no=stmt.executeUpdate();
		if(no>=1)
		return "true";
		else
		return "false";	
	}
	catch(Exception e)
	{
		return "<b><font color='black'>ERROR:Causes May Be,</font></b><br/><span style='font-weight:none;'>1.&nbsp;Fund In Entered May Be Incorrect <br/> 2.&nbsp;There May Be Error With Our DataBase<br/> Server</span>";
	}
	finally{
		try {
			conn.close();
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
}


}
 