import java.io.* ;
import java.math.*;
import java.util.*;
public class rsa
{
public static void main ( String []args ) throws Exception 
{
BigInteger p = new BigInteger ( 50,10, new Random () ) ;
BigInteger q = new BigInteger ( 50,10, new Random () ) ;
BigInteger n = p.multiply ( q ) ;
BigInteger  e,d;
System.out.println ( "P = " + p + "\nQ = " + q + "\nN = " + n ) ;
BigInteger t = p.subtract(BigInteger.ONE).multiply(q.subtract(BigInteger.ONE)) ;
do
{
e = new BigInteger( 50,10, new Random() ) ;
} while ( t.gcd(e) == BigInteger.ONE ) ;
d = e.modInverse ( t ) ;
System.out.println ( "E = " + e + "\nD = " + d ) ;
System.out.println("Enter message");
BufferedReader br=new BufferedReader(new InputStreamReader(System.in));
String message=br.readLine();
System.out.println("Encrypted Message");
int i ;
byte[] temp = new byte[1] ;
byte[] digits = message.getBytes() ;
BigInteger[] bigdigits = new BigInteger[digits.length] ;
for( i = 0 ; i < bigdigits.length ; i++ ) 
{
temp[0] = digits[i] ;
bigdigits[i] = new BigInteger( temp ) ;
}
BigInteger[] encrypted = new BigInteger[bigdigits.length] ;
for( i = 0 ; i < bigdigits.length ; i++ )
{
encrypted[i] = bigdigits[i].modPow( e, n ) ;
System.out.print(encrypted[i]);
}
System.out.println("\n\nDecrypted Message");
BigInteger[] decrypted = new BigInteger[encrypted.length] ;
for( i = 0 ; i < decrypted.length ; i++ )
	decrypted[i] = encrypted[i].modPow(d, n);
char[] charArray = new char[decrypted.length] ;
for( i = 0 ; i < charArray.length ; i++ )
	charArray[i] = (char) (decrypted[i].intValue());
System.out.println( new String(charArray)) ;
}
}

/* 
Sample output:

P = 19
Q = 23
N = 437
E = 19
D = 271
Enter message
this is the message to be encrpted by rsa algorithm
Encrypted Message
116123481151348115131161238213166821151153068482131162441341821
38233880114171168211913416413114115306133061278424411448116123166

Decrypted Message
this is the message to be encrpted by rsa algorithm

*/	
